=== modified file 'INSTALL'
--- INSTALL	2009-01-27 00:07:26 +0000
+++ INSTALL	2008-10-28 18:00:20 +0000
@@ -43,14 +43,13 @@
     + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
     + python-ctypes 1.0.0 http://pypi.python.org/pypi/ctypes
-    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
     
     Strongly recommended:
     + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-ctypes python-gobject
+    python-ctypes
    
 *** Mandos Client
     + initramfs-tools 0.85i

=== modified file 'Makefile'
--- Makefile	2009-01-17 02:12:05 +0000
+++ Makefile	2009-01-10 03:26:15 +0000
@@ -16,7 +16,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.5
+version=1.0.3
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -77,7 +77,7 @@
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo
 CPROGS=plugin-runner $(PLUGINS)
-PROGS=mandos mandos-keygen mandos-ctl $(CPROGS)
+PROGS=mandos mandos-keygen mandos-list $(CPROGS)
 DOCS=mandos.8 plugin-runner.8mandos mandos-keygen.8 \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos mandos.conf.5 \
@@ -164,7 +164,7 @@
 		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
 		$@
 
-mandos-ctl: Makefile
+mandos-list: Makefile
 	$(SED) --in-place \
 		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
 		$@

=== modified file 'NEWS'
--- NEWS	2009-01-17 02:12:05 +0000
+++ NEWS	2009-01-06 02:42:53 +0000
@@ -1,22 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.0.5 (2009-01-17)
-* Client
-** Fix small memory leak in plugin-runner.
-
-Version 1.0.4 (2009-01-15)
-* Server
-** Only find matched user/group pairs when searching for suitable
-   nonprivileged user/group to switch to.
-
-* Client
-** New kernel parameter "mandos=off" makes client not run at boot.
-** Fix linking errors and compilation warnings on AMD64.
-** Parse numbers in command line options better.
-** The splashy and usplash plugins are more robust while traversing
-   /proc, and will not abort if a process suddenly disappears.
-
 Version 1.0.3 (2009-01-06)
 * Server
 ** Now tries to change to user and group "_mandos" before falling back

=== modified file 'TODO'
--- TODO	2009-01-23 20:09:55 +0000
+++ TODO	2009-01-12 22:02:33 +0000
@@ -1,7 +1,6 @@
 -*- org -*-
 
 * mandos-client
-** TODO [#A] Clean up /tmp directory on signal
 ** TODO [#B] Temporarily lower kernel log level
    for less printouts during sucessfull boot.
    klogctl(6, NULL, 0); klogctl(7, NULL, 0);
@@ -54,13 +53,16 @@
 ** TODO [#B] "--test" option
    For testing decryption before rebooting.
 
-* Package
+* [#A] Package
 ** /usr/share/initramfs-tools/hooks/mandos
 *** TODO [#C] Do not install in initrd.img if configured not to.
     Use "/etc/initramfs-tools/conf.d/mandos"?  Definitely a debconf
     question.
 ** TODO [#C] /etc/bash_completion.d/mandos
    From XML sources directly?
+** TODO initramfs-tools-script						  :test:
+   Do not insert plugin-runner as keyscript if a kernel parameter
+   "mandos=off" is passed.
 
 
 #+STARTUP: showall

=== modified file 'debian/changelog'
--- debian/changelog	2009-01-17 02:12:05 +0000
+++ debian/changelog	2009-01-06 22:43:19 +0000
@@ -1,18 +1,3 @@
-mandos (1.0.5-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sat, 17 Jan 2009 02:26:00 +0100
-
-mandos (1.0.4-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/watch: New file.
-  * debian/mandos-client.README.Debian: Document new "mandos=off" kernel
-    parameter.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 15 Jan 2009 05:49:22 +0100
-
 mandos (1.0.3-2) unstable; urgency=low
 
   * Removed some now-unused debconf files.

=== modified file 'debian/control'
--- debian/control	2009-01-26 23:47:44 +0000
+++ debian/control	2009-01-06 20:39:35 +0000
@@ -15,8 +15,7 @@
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
-	python-avahi, python-gobject, avahi-daemon, gnupg (< 2),
-	adduser
+	python-avahi, avahi-daemon, gnupg (< 2), adduser
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2009-01-15 02:52:02 +0000
+++ debian/mandos-client.README.Debian	2008-10-05 17:38:31 +0000
@@ -42,10 +42,4 @@
   Mandos client will be the new default way for getting a password for
   the root file system when booting.
 
-* Emergency Escape
-  
-  If it ever should be necessary, the Mandos client can be temporarily
-  prevented from running at startup by passing the parameter
-  "mandos=off" to the kernel.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Mon, 12 Jan 2009 02:29:10 +0100
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Sun,  5 Oct 2008 19:04:26 +0200

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2009-01-18 06:41:57 +0000
+++ debian/mandos-client.lintian-overrides	2008-10-01 15:29:01 +0000
@@ -1,3 +1,8 @@
+# This example command line is long without spaces, but it must be
+# that way; it's part of the point of showing it.
+#
+mandos-client binary: manpage-has-errors-from-man usr/share/man/man8/plugin-runner.8mandos.gz 297: warning [p 4, 5.8i]: can't break line
+
 # This directory contains secret client key files.
 #
 mandos-client binary: non-standard-dir-perm etc/keys/mandos/ 0700 != 0755
@@ -11,7 +16,7 @@
 
 # These binaries must be setuid root, since they need root powers, but
 # are started by plugin-runner(8mandos), which runs all plugins as
-# user/group "_mandos".  These binaries are not run in a running
+# user/group "mandos".  These binaries are not run in a running
 # system, but in an initial RAM disk environment.  Here they are
 # protected from non-root access by the directory permissions, above.
 #

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2009-01-18 00:16:57 +0000
+++ debian/mandos-client.postinst	2009-01-06 05:08:37 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/bash -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -26,7 +26,7 @@
 # Add user and group
 add_mandos_user(){
     # Rename old "mandos" user and group
-    case "`getent passwd mandos`" in
+    case "$(getent passwd mandos)" in
 	*:Mandos\ password\ system,,,:/nonexistent:/bin/false)
 	    usermod --login _mandos mandos
 	    groupmod --new-name _mandos mandos
@@ -62,7 +62,7 @@
 	;;
 
     *)
-	echo "$0 called with unknown argument '$1'" 1>&2
+	echo "$0 called with unknown argument \`$1'" 1>&2
 	exit 1
 	;;
 esac

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2009-01-18 00:16:57 +0000
+++ debian/mandos-client.postrm	2008-09-19 20:54:58 +0000
@@ -50,7 +50,7 @@
 	;;
 
     *)
-	echo "$0 called with unknown argument '$1'" 1>&2
+	echo "$0 called with unknown argument \`$1'" 1>&2
 	exit 1
 	;;
 esac

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2009-01-18 00:16:57 +0000
+++ debian/mandos.postinst	2009-01-06 05:08:37 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/bash -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -18,7 +18,7 @@
 case "$1" in
     configure)
 	# Rename old "mandos" user and group
-	case "`getent passwd mandos`" in
+	case "$(getent passwd mandos)" in
 	    *:Mandos\ password\ system,,,:/nonexistent:/bin/false)
 		usermod --login _mandos mandos
 		groupmod --new-name _mandos mandos
@@ -37,7 +37,7 @@
 	;;
 
     *)
-	echo "$0 called with unknown argument '$1'" 1>&2
+	echo "$0 called with unknown argument \`$1'" 1>&2
 	exit 1
 	;;
 esac

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2009-01-18 00:16:57 +0000
+++ debian/mandos.prerm	2008-09-21 13:42:34 +0000
@@ -6,12 +6,12 @@
 set -e
 
 # summary of how this script can be called:
-#        * <prerm> 'remove'
-#        * <old-prerm> 'upgrade' <new-version>
-#        * <new-prerm> 'failed-upgrade' <old-version>
-#        * <conflictor's-prerm> 'remove' 'in-favour' <package> <new-version>
-#        * <deconfigured's-prerm> 'deconfigure' 'in-favour'
-#          <package-being-installed> <version> 'removing'
+#        * <prerm> `remove'
+#        * <old-prerm> `upgrade' <new-version>
+#        * <new-prerm> `failed-upgrade' <old-version>
+#        * <conflictor's-prerm> `remove' `in-favour' <package> <new-version>
+#        * <deconfigured's-prerm> `deconfigure' `in-favour'
+#          <package-being-installed> <version> `removing'
 #          <conflicting-package> <version>
 # for details, see /usr/share/doc/packaging-manual/
 
@@ -28,7 +28,7 @@
     upgrade|failed-upgrade)
         ;;
     *)
-        echo "prerm called with unknown argument '$1'" >&2
+        echo "prerm called with unknown argument \`$1'" >&2
         exit 0
     ;;
 esac

=== modified file 'debian/rules'
--- debian/rules	2009-01-18 00:18:50 +0000
+++ debian/rules	2009-01-04 22:26:07 +0000
@@ -47,7 +47,7 @@
 	dh_installdirs --indep
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
 	dh_lintian
-	dh_installinit --onlyscripts \
+	dh_installinit --onlyscripts --no-start \
 		--update-rcd-params="defaults 25 15"
 	dh_install --indep
 

=== removed file 'debian/watch'
--- debian/watch	2009-01-15 02:52:02 +0000
+++ debian/watch	1970-01-01 00:00:00 +0000
@@ -1,2 +0,0 @@
-version=3
-ftp://ftp.fukt.bsnet.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z)

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2009-01-15 02:52:02 +0000
+++ initramfs-tools-script	2008-09-07 15:42:11 +0000
@@ -24,12 +24,6 @@
      ;;
 esac
 
-for param in `cat /proc/cmdline`; do
-    case "$param" in
-	mandos=off) exit 0;;
-    esac
-done
-
 chmod a=rwxt /tmp
 
 test -w /conf/conf.d/cryptroot

=== modified file 'mandos'
--- mandos	2009-01-28 11:23:12 +0000
+++ mandos	2009-01-08 03:54:06 +0000
@@ -35,7 +35,7 @@
 
 import SocketServer
 import socket
-import optparse
+from optparse import OptionParser
 import datetime
 import errno
 import gnutls.crypto
@@ -66,7 +66,7 @@
 import ctypes
 import ctypes.util
 
-version = "1.0.5"
+version = "1.0.3"
 
 logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
@@ -178,8 +178,7 @@
 class Client(dbus.service.Object):
     """A representation of a client host served by this server.
     Attributes:
-    name:       string; from the config file, used in log messages and
-                        D-Bus identifiers
+    name:       string; from the config file, used in log messages
     fingerprint: string (40 or 32 hexadecimal digits); used to
                  uniquely identify the client
     secret:     bytestring; sent verbatim (over TLS) to client
@@ -226,7 +225,13 @@
         if config is None:
             config = {}
         logger.debug(u"Creating client %r", self.name)
-        self.use_dbus = False   # During __init__
+        self.use_dbus = use_dbus
+        if self.use_dbus:
+            self.dbus_object_path = (dbus.ObjectPath
+                                     ("/Mandos/clients/"
+                                      + self.name.replace(".", "_")))
+            dbus.service.Object.__init__(self, bus,
+                                         self.dbus_object_path)
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
@@ -256,16 +261,6 @@
         self.disable_initiator_tag = None
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
-        self.last_connect = None
-        # Only now, when this client is initialized, can it show up on
-        # the D-Bus
-        self.use_dbus = use_dbus
-        if self.use_dbus:
-            self.dbus_object_path = (dbus.ObjectPath
-                                     ("/clients/"
-                                      + self.name.replace(".", "_")))
-            dbus.service.Object.__init__(self, bus,
-                                         self.dbus_object_path)
     
     def enable(self):
         """Start this client's checker and timeout hooks"""
@@ -324,30 +319,34 @@
             # Emit D-Bus signal
             self.PropertyChanged(dbus.String(u"checker_running"),
                                  dbus.Boolean(False, variant_level=1))
-        if os.WIFEXITED(condition):
-            exitstatus = os.WEXITSTATUS(condition)
-            if exitstatus == 0:
-                logger.info(u"Checker for %(name)s succeeded",
-                            vars(self))
-                self.checked_ok()
-            else:
-                logger.info(u"Checker for %(name)s failed",
-                            vars(self))
+        if (os.WIFEXITED(condition)
+            and (os.WEXITSTATUS(condition) == 0)):
+            logger.info(u"Checker for %(name)s succeeded",
+                        vars(self))
             if self.use_dbus:
                 # Emit D-Bus signal
-                self.CheckerCompleted(dbus.Int16(exitstatus),
-                                      dbus.Int64(condition),
+                self.CheckerCompleted(dbus.Boolean(True),
+                                      dbus.UInt16(condition),
                                       dbus.String(command))
-        else:
+            self.bump_timeout()
+        elif not os.WIFEXITED(condition):
             logger.warning(u"Checker for %(name)s crashed?",
                            vars(self))
             if self.use_dbus:
                 # Emit D-Bus signal
-                self.CheckerCompleted(dbus.Int16(-1),
-                                      dbus.Int64(condition),
+                self.CheckerCompleted(dbus.Boolean(False),
+                                      dbus.UInt16(condition),
+                                      dbus.String(command))
+        else:
+            logger.info(u"Checker for %(name)s failed",
+                        vars(self))
+            if self.use_dbus:
+                # Emit D-Bus signal
+                self.CheckerCompleted(dbus.Boolean(False),
+                                      dbus.UInt16(condition),
                                       dbus.String(command))
     
-    def checked_ok(self):
+    def bump_timeout(self):
         """Bump up the timeout for this client.
         This should only be called when the client has been seen,
         alive and well.
@@ -449,15 +448,15 @@
             return now < (self.last_checked_ok + self.timeout)
     
     ## D-Bus methods & signals
-    _interface = u"se.bsnet.fukt.Mandos.Client"
+    _interface = u"org.mandos_system.Mandos.Client"
     
-    # CheckedOK - method
-    CheckedOK = dbus.service.method(_interface)(checked_ok)
-    CheckedOK.__name__ = "CheckedOK"
+    # BumpTimeout - method
+    BumpTimeout = dbus.service.method(_interface)(bump_timeout)
+    BumpTimeout.__name__ = "BumpTimeout"
     
     # CheckerCompleted - signal
-    @dbus.service.signal(_interface, signature="nxs")
-    def CheckerCompleted(self, exitcode, waitstatus, command):
+    @dbus.service.signal(_interface, signature="bqs")
+    def CheckerCompleted(self, success, condition, command):
         "D-Bus signal"
         pass
     
@@ -504,9 +503,6 @@
                 dbus.String("checker_running"):
                     dbus.Boolean(self.checker is not None,
                                  variant_level=1),
-                dbus.String("object_path"):
-                    dbus.ObjectPath(self.dbus_object_path,
-                                    variant_level=1)
                 }, signature="sv")
     
     # IsStillValid - method
@@ -595,13 +591,10 @@
         != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
         # ...do the normal thing
         return session.peer_certificate
-    list_size = ctypes.c_uint(1)
+    list_size = ctypes.c_uint()
     cert_list = (gnutls.library.functions
                  .gnutls_certificate_get_peers
                  (session._c_object, ctypes.byref(list_size)))
-    if not bool(cert_list) and list_size.value != 0:
-        raise gnutls.errors.GNUTLSError("error getting peer"
-                                        " certificate")
     if list_size.value == 0:
         return None
     cert = cert_list[0]
@@ -656,108 +649,78 @@
     def handle(self):
         logger.info(u"TCP connection from: %s",
                     unicode(self.client_address))
-        logger.debug(u"Pipe: %d", self.server.pipe[1])
-        # Open IPC pipe to parent process
-        with closing(os.fdopen(self.server.pipe[1], "w", 1)) as ipc:
-            session = (gnutls.connection
-                       .ClientSession(self.request,
-                                      gnutls.connection
-                                      .X509Credentials()))
-            
-            line = self.request.makefile().readline()
-            logger.debug(u"Protocol version: %r", line)
-            try:
-                if int(line.strip().split()[0]) > 1:
-                    raise RuntimeError
-            except (ValueError, IndexError, RuntimeError), error:
-                logger.error(u"Unknown protocol version: %s", error)
-                return
-            
-            # Note: gnutls.connection.X509Credentials is really a
-            # generic GnuTLS certificate credentials object so long as
-            # no X.509 keys are added to it.  Therefore, we can use it
-            # here despite using OpenPGP certificates.
-            
-            #priority = ':'.join(("NONE", "+VERS-TLS1.1",
-            #                     "+AES-256-CBC", "+SHA1",
-            #                     "+COMP-NULL", "+CTYPE-OPENPGP",
-            #                     "+DHE-DSS"))
-            # Use a fallback default, since this MUST be set.
-            priority = self.server.settings.get("priority", "NORMAL")
-            (gnutls.library.functions
-             .gnutls_priority_set_direct(session._c_object,
-                                         priority, None))
-
-            try:
-                session.handshake()
-            except gnutls.errors.GNUTLSError, error:
-                logger.warning(u"Handshake failed: %s", error)
-                # Do not run session.bye() here: the session is not
-                # established.  Just abandon the request.
-                return
-            logger.debug(u"Handshake succeeded")
-            try:
-                fpr = fingerprint(peer_certificate(session))
-            except (TypeError, gnutls.errors.GNUTLSError), error:
-                logger.warning(u"Bad certificate: %s", error)
-                session.bye()
-                return
-            logger.debug(u"Fingerprint: %s", fpr)
-            for c in self.server.clients:
-                if c.fingerprint == fpr:
-                    client = c
-                    break
-            else:
-                logger.warning(u"Client not found for fingerprint: %s",
-                               fpr)
-                ipc.write("NOTFOUND %s\n" % fpr)
-                session.bye()
-                return
-            # Have to check if client.still_valid(), since it is
-            # possible that the client timed out while establishing
-            # the GnuTLS session.
-            if not client.still_valid():
-                logger.warning(u"Client %(name)s is invalid",
-                               vars(client))
-                ipc.write("INVALID %s\n" % client.name)
-                session.bye()
-                return
-            ipc.write("SENDING %s\n" % client.name)
-            ## This won't work here, since we're in a fork.
-            # client.checked_ok()
-            sent_size = 0
-            while sent_size < len(client.secret):
-                sent = session.send(client.secret[sent_size:])
-                logger.debug(u"Sent: %d, remaining: %d",
-                             sent, len(client.secret)
-                             - (sent_size + sent))
-                sent_size += sent
-            session.bye()
-
-
-class ForkingMixInWithPipe(SocketServer.ForkingMixIn, object):
-    """Like SocketServer.ForkingMixIn, but also pass a pipe.
-    Assumes a gobject.MainLoop event loop.
-    """
-    def process_request(self, request, client_address):
-        """This overrides and wraps the original process_request().
-        This function creates a new pipe in self.pipe 
-        """
-        self.pipe = os.pipe()
-        super(ForkingMixInWithPipe,
-              self).process_request(request, client_address)
-        os.close(self.pipe[1])  # close write end
-        # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(self.pipe[0],
-                             gobject.IO_IN | gobject.IO_HUP,
-                             self.handle_ipc)
-    def handle_ipc(source, condition):
-        """Dummy function; override as necessary"""
-        os.close(source)
-        return False
-
-
-class IPv6_TCPServer(ForkingMixInWithPipe,
+        session = (gnutls.connection
+                   .ClientSession(self.request,
+                                  gnutls.connection
+                                  .X509Credentials()))
+        
+        line = self.request.makefile().readline()
+        logger.debug(u"Protocol version: %r", line)
+        try:
+            if int(line.strip().split()[0]) > 1:
+                raise RuntimeError
+        except (ValueError, IndexError, RuntimeError), error:
+            logger.error(u"Unknown protocol version: %s", error)
+            return
+        
+        # Note: gnutls.connection.X509Credentials is really a generic
+        # GnuTLS certificate credentials object so long as no X.509
+        # keys are added to it.  Therefore, we can use it here despite
+        # using OpenPGP certificates.
+        
+        #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
+        #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
+        #                "+DHE-DSS"))
+        # Use a fallback default, since this MUST be set.
+        priority = self.server.settings.get("priority", "NORMAL")
+        (gnutls.library.functions
+         .gnutls_priority_set_direct(session._c_object,
+                                     priority, None))
+        
+        try:
+            session.handshake()
+        except gnutls.errors.GNUTLSError, error:
+            logger.warning(u"Handshake failed: %s", error)
+            # Do not run session.bye() here: the session is not
+            # established.  Just abandon the request.
+            return
+        try:
+            fpr = fingerprint(peer_certificate(session))
+        except (TypeError, gnutls.errors.GNUTLSError), error:
+            logger.warning(u"Bad certificate: %s", error)
+            session.bye()
+            return
+        logger.debug(u"Fingerprint: %s", fpr)
+        for c in self.server.clients:
+            if c.fingerprint == fpr:
+                client = c
+                break
+        else:
+            logger.warning(u"Client not found for fingerprint: %s",
+                           fpr)
+            session.bye()
+            return
+        # Have to check if client.still_valid(), since it is possible
+        # that the client timed out while establishing the GnuTLS
+        # session.
+        if not client.still_valid():
+            logger.warning(u"Client %(name)s is invalid",
+                           vars(client))
+            session.bye()
+            return
+        ## This won't work here, since we're in a fork.
+        # client.bump_timeout()
+        sent_size = 0
+        while sent_size < len(client.secret):
+            sent = session.send(client.secret[sent_size:])
+            logger.debug(u"Sent: %d, remaining: %d",
+                         sent, len(client.secret)
+                         - (sent_size + sent))
+            sent_size += sent
+        session.bye()
+
+
+class IPv6_TCPServer(SocketServer.ForkingMixIn,
                      SocketServer.TCPServer, object):
     """IPv6 TCP server.  Accepts 'None' as address and/or port.
     Attributes:
@@ -815,39 +778,6 @@
             return super(IPv6_TCPServer, self).server_activate()
     def enable(self):
         self.enabled = True
-    def handle_ipc(self, source, condition, file_objects={}):
-        logger.debug("Handling IPC: %r : %r", source, condition)
-        
-        # Turn a file descriptor into a Python file object
-        if source not in file_objects:
-            file_objects[source] = os.fdopen(source, "r", 1)
-        
-        # Read a line from the file object
-        cmdline = file_objects[source].readline()
-        if not cmdline:             # Empty line means end of file
-            # close the IPC pipe
-            logger.debug("Closing: %r", source)
-            file_objects[source].close()
-            del file_objects[source]
-
-            # Stop calling this function
-            return False
-        
-        logger.debug("IPC command: %r\n" % cmdline)
-        
-        # Parse and act on command
-        cmd, args = cmdline.split(None, 1)
-        if cmd == "NOTFOUND":
-            pass                # xxx
-        elif cmd == "INVALID":
-            pass                # xxx
-        elif cmd == "SENDING":
-            pass                # xxx
-        else:
-            logger.error("Unknown IPC command: %r", cmdline)
-        
-        # Keep calling this function
-        return True
 
 
 def string_to_delta(interval):
@@ -959,7 +889,7 @@
 
 
 def main():
-    parser = optparse.OptionParser(version = "%%prog %s" % version)
+    parser = OptionParser(version = "%%prog %s" % version)
     parser.add_option("-i", "--interface", type="string",
                       metavar="IF", help="Bind to interface IF")
     parser.add_option("-a", "--address", type="string",
@@ -1007,14 +937,11 @@
     server_config.read(os.path.join(options.configdir, "mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
-    # Use the appropriate methods on the non-string config options
-    server_settings["debug"] = server_config.getboolean("DEFAULT",
-                                                        "debug")
-    server_settings["use_dbus"] = server_config.getboolean("DEFAULT",
-                                                           "use_dbus")
-    if server_settings["port"]:
-        server_settings["port"] = server_config.getint("DEFAULT",
-                                                       "port")
+    # Use getboolean on the boolean config options
+    server_settings["debug"] = (server_config.getboolean
+                                ("DEFAULT", "debug"))
+    server_settings["use_dbus"] = (server_config.getboolean
+                                   ("DEFAULT", "use_dbus"))
     del server_config
     
     # Override the settings from the config file with command line
@@ -1104,7 +1031,8 @@
                             avahi.DBUS_INTERFACE_SERVER)
     # End of Avahi example code
     if use_dbus:
-        bus_name = dbus.service.BusName(u"se.bsnet.fukt.Mandos", bus)
+        bus_name = dbus.service.BusName(u"org.mandos-system.Mandos",
+                                        bus)
     
     clients.update(Set(Client(name = section,
                               config
@@ -1164,35 +1092,33 @@
         class MandosServer(dbus.service.Object):
             """A D-Bus proxy object"""
             def __init__(self):
-                dbus.service.Object.__init__(self, bus, "/")
-            _interface = u"se.bsnet.fukt.Mandos"
-            
+                dbus.service.Object.__init__(self, bus,
+                                             "/Mandos")
+            _interface = u"org.mandos_system.Mandos"
+
             @dbus.service.signal(_interface, signature="oa{sv}")
             def ClientAdded(self, objpath, properties):
                 "D-Bus signal"
                 pass
-            
-            @dbus.service.signal(_interface, signature="os")
-            def ClientRemoved(self, objpath, name):
+
+            @dbus.service.signal(_interface, signature="o")
+            def ClientRemoved(self, objpath):
                 "D-Bus signal"
                 pass
-            
+
             @dbus.service.method(_interface, out_signature="ao")
             def GetAllClients(self):
-                "D-Bus method"
                 return dbus.Array(c.dbus_object_path for c in clients)
-            
+
             @dbus.service.method(_interface, out_signature="a{oa{sv}}")
             def GetAllClientsWithProperties(self):
-                "D-Bus method"
                 return dbus.Dictionary(
                     ((c.dbus_object_path, c.GetAllProperties())
                      for c in clients),
                     signature="oa{sv}")
-            
+
             @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
-                "D-Bus method"
                 for c in clients:
                     if c.dbus_object_path == object_path:
                         clients.remove(c)
@@ -1200,12 +1126,15 @@
                         c.use_dbus = False
                         c.disable()
                         # Emit D-Bus signal
-                        self.ClientRemoved(object_path, c.name)
+                        self.ClientRemoved(object_path)
                         return
                 raise KeyError
-            
+            @dbus.service.method(_interface)
+            def Quit(self):
+                main_loop.quit()
+
             del _interface
-        
+    
         mandos_server = MandosServer()
     
     for client in clients:

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-01-17 09:46:54 +0000
+++ mandos-keygen	2009-01-06 02:42:53 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.5"
+VERSION="1.0.3"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
@@ -147,7 +147,7 @@
 	echo "Invalid key length" >&2
 	exit 1
     fi
-    
+
     if [ -z "$KEYEXPIRE" ]; then
 	echo "Empty key expiration" >&2
 	exit 1
@@ -172,7 +172,7 @@
     if [ -n "$KEYEMAIL" ]; then
 	KEYEMAILLINE="Name-Email: $KEYEMAIL"
     fi
-    
+
     # Create temporary gpg batch file
     BATCHFILE="`mktemp -t mandos-keygen-batch.XXXXXXXXXX`"
 fi
@@ -284,7 +284,7 @@
 	stty echo
 	if [ "$first" != "$second" ]; then
 	    echo -e "Passphrase mismatch" >&2
-	    touch "$RINGDIR"/mismatch
+	    false
 	else
 	    echo -n "$first"
 	fi
@@ -292,9 +292,9 @@
 	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
 	--sign --recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
 	> "$SECFILE"
-    if [ -e "$RINGDIR"/mismatch ]; then
-	rm --force "$RINGDIR"/mismatch
-	exit 1
+    status="${PIPESTATUS[0]}"
+    if [ "$status" -ne 0 ]; then
+	exit "$status"
     fi
     
     cat <<-EOF

=== renamed file 'mandos-ctl' => 'mandos-list' (properties changed: -x to +x)
--- mandos-ctl	2009-01-17 02:12:05 +0000
+++ mandos-list	2008-12-21 19:19:25 +0000
@@ -1,13 +1,9 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
 
-from __future__ import division
-import sys
 import dbus
 from optparse import OptionParser
 import locale
-import datetime
-import re
 
 locale.setlocale(locale.LC_ALL, u'')
 
@@ -24,164 +20,46 @@
     'last_enabled': u'Last Enabled',
     'checker': u'Checker',
     }
+busname = 'org.mandos-system.Mandos'
+object_path = '/Mandos'
+interface = 'org.mandos_system.Mandos'
+version = "1.0.2"
 defaultkeywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
                    'checker')
-busname = 'org.mandos-system.Mandos'
-server_path = '/Mandos'
-server_interface = 'org.mandos_system.Mandos'
-client_interface = 'org.mandos_system.Mandos.Client'
-version = "1.0.5"
+
+parser = OptionParser(version = "%%prog %s" % version)
+parser.add_option("-a", "--all", action="store_true", default=False,
+                  help="Print all fields")
+options = parser.parse_args()[0]
+if options.all:
+    keywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
+                'created', 'interval', 'host', 'fingerprint',
+                'checker_running', 'last_enabled', 'checker')
+else:
+    keywords = defaultkeywords
+
 
 bus = dbus.SystemBus()
-mandos_dbus_objc = bus.get_object(busname, server_path)
+mandos_dbus_objc = bus.get_object(busname, object_path)
 mandos_serv = dbus.Interface(mandos_dbus_objc,
-                             dbus_interface = server_interface)
+                             dbus_interface = interface)
 mandos_clients = mandos_serv.GetAllClientsWithProperties()
 
-def datetime_to_milliseconds(dt):
-    "Return the 'timeout' attribute in milliseconds"
-    return ((dt.days * 24 * 60 * 60 * 1000)
-            + (dt.seconds * 1000)
-            + (dt.microseconds // 1000))
-
-def milliseconds_to_string(ms):
-    td = datetime.timedelta(0, 0, 0, ms)
-    return "%s%02d:%02d:%02d" % (("%dT" % td.days) if td.days else "", # days
-                           td.seconds // 3600,        # hours
-                           (td.seconds % 3600) // 60, # minutes
-                           (td.seconds % 60))         # seconds
-
-
-def string_to_delta(interval):
-    """Parse a string and return a datetime.timedelta
-
-    >>> string_to_delta('7d')
-    datetime.timedelta(7)
-    >>> string_to_delta('60s')
-    datetime.timedelta(0, 60)
-    >>> string_to_delta('60m')
-    datetime.timedelta(0, 3600)
-    >>> string_to_delta('24h')
-    datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
-    datetime.timedelta(7)
-    >>> string_to_delta('5m 30s')
-    datetime.timedelta(0, 330)
-    """
-    timevalue = datetime.timedelta(0)
-    regexp = re.compile("\d+[dsmhw]")
-    
-    for s in regexp.findall(interval):
-        try:
-            suffix = unicode(s[-1])
-            value = int(s[:-1])
-            if suffix == u"d":
-                delta = datetime.timedelta(value)
-            elif suffix == u"s":
-                delta = datetime.timedelta(0, value)
-            elif suffix == u"m":
-                delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == u"h":
-                delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == u"w":
-                delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
-            else:
-                raise ValueError
-        except (ValueError, IndexError):
-            raise ValueError
-        timevalue += delta
-    return timevalue
-
-def print_clients(clients):
-    def valuetostring(value, keyword):
-        if type(value) is dbus.Boolean:
-            return u"Yes" if value else u"No"
-        if keyword in ("timeout", "interval"):
-            return milliseconds_to_string(value)
-        return unicode(value)
-    
-    format_string = u' '.join(u'%%-%ds' %
-                              max(len(tablewords[key]),
-                                  max(len(valuetostring(client[key], key))
-                                      for client in
-                                      clients))
-                              for key in keywords)
-    print format_string % tuple(tablewords[key] for key in keywords) 
-    for client in clients:
-        print format_string % tuple(valuetostring(client[key], key)
-                                    for key in keywords)
-
-parser = OptionParser(version = "%%prog %s" % version)
-parser.add_option("-a", "--all", action="store_true",
-                  help="Print all fields")
-parser.add_option("-e", "--enable", action="store_true",
-                  help="Enable specified client")
-parser.add_option("-d", "--disable", action="store_true",
-                  help="disable specified client")
-parser.add_option("-b", "--bump-timeout", action="store_true",
-                  help="Bump timeout of specified client")
-parser.add_option("--start-checker", action="store_true",
-                  help="Start checker for specified client")
-parser.add_option("--stop-checker", action="store_true",
-                  help="Stop checker for specified client")
-parser.add_option("-v", "--is-valid", action="store_true",
-                  help="Stop checker for specified client")
-parser.add_option("-c", "--checker", type="string",
-                  help="Set checker command for specified client")
-parser.add_option("-t", "--timeout", type="string",
-                  help="Set timeout for specified client")
-parser.add_option("-i", "--interval", type="string",
-                  help="Set checker interval for specified client")
-parser.add_option("-H", "--host", type="string",
-                  help="Set host for specified client")
-parser.add_option("-s", "--secret", type="string",
-                  help="Set password blob (file) for specified client")
-options, client_names = parser.parse_args()
-
-clients=[]
-for name in client_names:
-    for path, client in mandos_clients.iteritems():
-        if client['name'] == name:
-            client_objc = bus.get_object(busname, path)
-            clients.append(dbus.Interface(client_objc,
-                                          dbus_interface
-                                          = client_interface))
-            break
+def valuetostring(x):
+    if type(x) is dbus.Boolean:
+        return u"Yes" if x else u"No"
     else:
-        print >> sys.stderr, "Client not found on server: %r" % name
-        sys.exit(1)
-
-if not clients:
-    keywords = defaultkeywords
-    if options.all:
-        keywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
-                    'created', 'interval', 'host', 'fingerprint',
-                    'checker_running', 'last_enabled', 'checker')
-    print_clients(mandos_clients.values())
-    
-for client in clients:
-    if options.enable:
-        client.Enable()
-    if options.disable:
-        client.Disable()
-    if options.bump_timeout:
-        client.BumpTimeout()
-    if options.start_checker:
-        client.StartChecker()
-    if options.stop_checker:
-        client.StopChecker()
-    if options.is_valid:
-        sys.exit(0 if client.IsStillValid() else 1)
-    if options.checker:
-        client.SetChecker(options.checker)
-    if options.host:
-        client.SetHost(options.host)
-    if options.interval:
-        client.SetInterval(datetime_to_milliseconds
-                           (string_to_delta(options.interval)))
-    if options.timeout:
-        client.SetTimeout(datetime_to_milliseconds
-                          (string_to_delta(options.timeout)))
-    if options.secret:
-        client.SetSecret(dbus.ByteArray(open(options.secret, 'rb').read()))
-    
+        return unicode(x)
+
+format_string = u' '.join(u'%%-%ds'
+                         % max(len(tablewords[key]),
+                               max(len(valuetostring(client[key]))
+                                   for client
+                                   in mandos_clients.itervalues()))
+                         for key in keywords)
+print format_string % tuple(tablewords[key] for key in keywords) 
+for client in mandos_clients.itervalues():
+    print format_string % tuple(valuetostring(client[key])
+                                for key in keywords)
+
+

=== modified file 'mandos.lsm'
--- mandos.lsm	2009-01-17 02:12:05 +0000
+++ mandos.lsm	2009-01-06 02:42:53 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.0.5
-Entered-date:	2009-01-17
+Version:	1.0.3
+Entered-date:	2009-01-06
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      94K mandos_1.0.5.orig.tar.gz
+	      92K mandos_1.0.3.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		94K mandos_1.0.5.orig.tar.gz
+		92K mandos_1.0.3.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.4, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2009-01-17 02:34:57 +0000
+++ plugin-runner.c	2009-01-14 14:20:17 +0000
@@ -115,7 +115,6 @@
   if(name != NULL){
     copy_name = strdup(name);
     if(copy_name == NULL){
-      free(new_plugin);
       return NULL;
     }
   }

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2009-01-18 06:41:57 +0000
+++ plugin-runner.xml	2009-01-04 21:54:55 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2009-01-17">
+<!ENTITY TIMESTAMP "2009-01-04">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -579,7 +579,7 @@
       <para>
 
 <!-- do not wrap this line -->
-<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/mandos/plugins.d --options-for=mandos-client:--pubkey=pubkey.txt,--seckey=seckey.txt</userinput>
+<userinput>&COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/mandos/plugins.d --options-for=mandos-client:--pubkey=/etc/keys/mandos/pubkey.txt,--seckey=/etc/keys/mandos/seckey.txt</userinput>
 
       </para>
     </informalexample>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2009-01-27 15:42:41 +0000
+++ plugins.d/mandos-client.c	2009-01-14 14:20:17 +0000
@@ -36,8 +36,7 @@
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror(), sscanf(),
-				   remove() */
+				   stdout, ferror(), sscanf */
 #include <stdint.h> 		/* uint16_t, uint32_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, EXIT_FAILURE,
@@ -154,7 +153,7 @@
   
   
   /*
-   * Helper function to insert pub and seckey to the engine keyring.
+   * Helper function to insert pub and seckey to the enigne keyring.
    */
   bool import_key(const char *filename){
     int fd;
@@ -832,7 +831,6 @@
     gid_t gid;
     char *connect_to = NULL;
     char tempdir[] = "/tmp/mandosXXXXXX";
-    bool tempdir_created = false;
     AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
     const char *seckey = PATHDIR "/" SECKEY;
     const char *pubkey = PATHDIR "/" PUBKEY;
@@ -840,8 +838,8 @@
     mandos_context mc = { .simple_poll = NULL, .server = NULL,
 			  .dh_bits = 1024, .priority = "SECURE256"
 			  ":!CTYPE-X.509:+CTYPE-OPENPGP" };
-    bool gnutls_initialized = false;
-    bool gpgme_initialized = false;
+    bool gnutls_initalized = false;
+    bool gpgme_initalized = false;
     
     {
       struct argp_option options[] = {
@@ -977,28 +975,27 @@
       exitcode = EXIT_FAILURE;
       goto end;
     } else {
-      gnutls_initialized = true;
+      gnutls_initalized = true;
     }
     
     if(mkdtemp(tempdir) == NULL){
       perror("mkdtemp");
+      tempdir[0] = '\0';
       goto end;
     }
-    tempdir_created = true;
     
     if(not init_gpgme(&mc, pubkey, seckey, tempdir)){
-      fprintf(stderr, "init_gpgme failed\n");
+      fprintf(stderr, "gpgme_initalized failed\n");
       exitcode = EXIT_FAILURE;
       goto end;
     } else {
-      gpgme_initialized = true;
+      gpgme_initalized = true;
     }
     
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
       fprintf(stderr, "No such interface: \"%s\"\n", interface);
-      exitcode = EXIT_FAILURE;
-      goto end;
+      exit(EXIT_FAILURE);
     }
     
     if(connect_to != NULL){
@@ -1108,18 +1105,18 @@
     if(mc.simple_poll != NULL)
         avahi_simple_poll_free(mc.simple_poll);
     
-    if(gnutls_initialized){
+    if(gnutls_initalized){
       gnutls_certificate_free_credentials(mc.cred);
       gnutls_global_deinit();
       gnutls_dh_params_deinit(mc.dh_params);
     }
     
-    if(gpgme_initialized){
+    if(gpgme_initalized){
       gpgme_release(mc.ctx);
     }
     
     /* Removes the temp directory used by GPGME */
-    if(tempdir_created){
+    if(tempdir[0] != '\0'){
       DIR *d;
       struct dirent *direntry;
       d = opendir(tempdir);
@@ -1133,26 +1130,21 @@
 	  if(direntry == NULL){
 	    break;
 	  }
-	  /* Skip "." and ".." */
-	  if(direntry->d_name[0] == '.'
-	     and (direntry->d_name[1] == '\0'
-		  or (direntry->d_name[1] == '.'
-		      and direntry->d_name[2] == '\0'))){
-	    continue;
-	  }
-	  char *fullname = NULL;
-	  ret = asprintf(&fullname, "%s/%s", tempdir,
-			 direntry->d_name);
-	  if(ret < 0){
-	    perror("asprintf");
-	    continue;
-	  }
-	  ret = remove(fullname);
-	  if(ret == -1){
-	    fprintf(stderr, "remove(\"%s\"): %s\n", fullname,
-		    strerror(errno));
-	  }
-	  free(fullname);
+	  if(direntry->d_type == DT_REG){
+	    char *fullname = NULL;
+	    ret = asprintf(&fullname, "%s/%s", tempdir,
+			   direntry->d_name);
+	    if(ret < 0){
+	      perror("asprintf");
+	      continue;
+	    }
+	    ret = unlink(fullname);
+	    if(ret == -1){
+	      fprintf(stderr, "unlink(\"%s\"): %s",
+		      fullname, strerror(errno));
+	    }
+	    free(fullname);
+	  }
 	}
 	closedir(d);
       }
@@ -1161,6 +1153,6 @@
 	perror("rmdir");
       }
     }
-    
+	  
     return exitcode;
 }

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2009-01-24 15:26:43 +0000
+++ plugins.d/mandos-client.xml	2009-01-04 21:54:55 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2009-01-24">
+<!ENTITY TIMESTAMP "2009-01-04">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -122,16 +122,11 @@
       <command>&COMMANDNAME;</command> is a client program that
       communicates with <citerefentry><refentrytitle
       >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      to get a password.  In slightly more detail, this client program
-      brings up a network interface, uses the interface’s IPv6
-      link-local address to get network connectivity, uses Zeroconf to
-      find servers on the local network, and communicates with servers
-      using TLS with an OpenPGP key to ensure authenticity and
-      confidentiality.  This client program keeps running, trying all
-      servers on the network, until it receives a satisfactory reply
-      or a TERM signal is received.  If no servers are found, or after
-      all servers have been tried, it waits indefinitely for new
-      servers to appear.
+      to get a password.  It uses IPv6 link-local addresses to get
+      network connectivity, Zeroconf to find servers, and TLS with an
+      OpenPGP key to ensure authenticity and confidentiality.  It
+      keeps running, trying all servers on the network, until it
+      receives a satisfactory reply or a TERM signal is received.
     </para>
     <para>
       This program is not meant to be run directly; it is really meant
@@ -206,15 +201,6 @@
 	    specifies the interface to use to connect to the address
 	    given.
 	  </para>
-	  <para>
-	    Note that since this program will normally run in the
-	    initial RAM disk environment, the interface must be an
-	    interface which exists at that stage.  Thus, the interface
-	    can not be a pseudo-interface such as <quote>br0</quote>
-	    or <quote>tun0</quote>; such interfaces will not exist
-	    until much later in the boot process, and can not be used
-	    by this program.
-	  </para>
 	</listitem>
       </varlistentry>
       

